"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransferRawMapper = exports.TransferMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const aw_antelope_1 = require("@alien-worlds/aw-antelope");
const entities_1 = require("../../domain/entities");
class TransferMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('from', {
            key: 'from',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('to', {
            key: 'to',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('quantity', {
            key: 'quantity',
            mapper: (value) => new aw_antelope_1.AssetMongoMapper().fromEntity(value),
        });
        this.mappingFromEntity.set('memo', {
            key: 'memo',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { from, to, quantity, memo, _id, ...rest } = mongoModel;
        return entities_1.Transfer.create(from || '', to || '', quantity ? new aw_antelope_1.AssetMongoMapper().toEntity(quantity) : aw_antelope_1.Asset.getDefault(), memo || '', _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.TransferMongoMapper = TransferMongoMapper;
class TransferRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { from, to, quantity, memo, ...rest } = rawModel;
        return entities_1.Transfer.create(from || '', to || '', quantity ? new aw_antelope_1.AssetRawMapper().toEntity(quantity) : aw_antelope_1.Asset.getDefault(), memo || '', undefined, rest);
    }
}
exports.TransferRawMapper = TransferRawMapper;
